﻿Imports System.Drawing.Imaging

Public Class Form1
  Dim D As Integer = 200
  Dim O(2) As Body
  Dim G As Single = 50
  Dim BM As New Bitmap(600, 600)
  Dim BMg As Graphics
  Dim Running As Boolean = False
  Dim omega As Double
  Dim angle As Double
  Dim Collision As Boolean

  Private Structure Body
    Dim M As Double
    Dim R As Integer
    Dim C As SolidBrush
    Dim XP, YP As Double
    Dim XV, YV As Double
    Dim XA, YA As Double
  End Structure


  Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    BMg = Graphics.FromImage(BM)
    BMg.TranslateTransform(300, 300)
    RadioButton1.Checked = True
    RadioButton8.Checked = True
    Label4.Text = ""
    Label8.Text = ""
    Reset()
    O(0).C = New SolidBrush(Color.Yellow)
    O(1).C = New SolidBrush(Color.SkyBlue)
    O(2).C = New SolidBrush(Color.Red)
    O(0).M = NumericUpDown1.Value
    O(1).M = NumericUpDown2.Value
    O(2).M = NumericUpDown3.Value
    GetRadius()
    Timer1.Interval = 10 ' fast
  End Sub

  Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
    SetAccel()
    UpdateAccel(0, 1)
    UpdateAccel(2, 1)
    UpdateAccel(2, 0)
    If Collision Then
      Label8.Text = "Collision occured"
      StopRunning()
    Else
      UpdateObjects()
      Label4.Text = "Orbit No." & Str(1 + angle \ 360)
      PictureBox1.Invalidate()
    End If
  End Sub

  Private Sub SetAccel()
    For p As Integer = 0 To 2
      O(p).XA = 0 : O(p).YA = 0
    Next
  End Sub

  Private Sub UpdateAccel(p, q)
    Dim Dsquared As Single = (O(p).XP - O(q).XP) ^ 2 + (O(p).YP - O(q).YP) ^ 2
    If Dsquared < 1 Then Dsquared = 1
    Dim Distance As Single = Math.Sqrt(Dsquared)
    If Distance < O(p).R + O(q).R And CheckBox4.Checked Then Collision = True
    If Distance > 1000 Then
      Label8.Text = "Satellite ejected from system"
      StopRunning()
    End If
    O(p).XA += G * O(q).M / Dsquared * (O(q).XP - O(p).XP) / Distance
    O(p).YA += G * O(q).M / Dsquared * (O(q).YP - O(p).YP) / Distance
    O(q).XA += G * O(p).M / Dsquared * (O(p).XP - O(q).XP) / Distance
    O(q).YA += G * O(p).M / Dsquared * (O(p).YP - O(q).YP) / Distance
  End Sub

  Private Sub UpdateObjects()
    For p As Integer = 0 To 2
      O(p).XV += O(p).XA : O(p).YV += O(p).YA
      O(p).XP += O(p).XV : O(p).YP += O(p).YV
    Next
  End Sub

  Private Sub PlotBody(g As Graphics, p As Integer)
    g.FillEllipse(O(p).C, CInt(O(p).XP - O(p).R), CInt(O(p).YP - O(p).R), O(p).R * 2, O(p).R * 2)
  End Sub

  Private Sub PlotDot(g As Graphics, p As Integer)
    g.FillEllipse(O(p).C, CInt(O(p).XP - 2), CInt(O(p).YP - 2), 4, 4)
  End Sub

  Private Sub PictureBox1_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseClick
    If RadioButton7.Checked And Not Running Then
      O(2).XP = e.X - 300 : O(2).YP = e.Y - 300
      Reset()
    End If
  End Sub

  Private Sub PictureBox1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    angle -= 180 * omega / Math.PI
    If CheckBox2.Checked Then
      BMg.ResetTransform()
      BMg.TranslateTransform(300, 300)
      BMg.RotateTransform(angle)
    End If
    If CheckBox1.Checked Then PlotDot(BMg, 1) : PlotDot(BMg, 2)
    e.Graphics.DrawImage(BM, 0, 0)
    e.Graphics.TranslateTransform(300, 300)
    If CheckBox2.Checked Then e.Graphics.RotateTransform(angle)
    PlotBody(e.Graphics, 0) : PlotBody(e.Graphics, 1) : PlotBody(e.Graphics, 2)
  End Sub

  Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    If Running Then
      StopRunning()
    Else
      StartRunning()
    End If
  End Sub
  Private Sub StartRunning()
    Timer1.Start()
    Button1.Text = "Stop"
    Collision = False
    Running = True
  End Sub

  Private Sub GetRadius()
    For b = 0 To 2
      O(b).R = 2 * Math.Sqrt(O(b).M)
      If O(b).R < 2 Then O(b).R = 2
    Next
  End Sub

  Private Sub StopRunning()
    Timer1.Stop()
    Button1.Text = "Go"
    Running = False
  End Sub

  Private Sub Reset()
    StopRunning()
    O(0).M = NumericUpDown1.Value
    O(1).M = NumericUpDown2.Value
    O(2).M = NumericUpDown3.Value
    O(0).XP = -D * O(1).M / (O(0).M + O(1).M) : O(0).YP = 0
    O(1).XP = D * O(0).M / (O(0).M + O(1).M) : O(1).YP = 0
    ' set up initial velocity of the planet so that the orbit is circular
    O(1).XV = 0
    O(1).YV = -Math.Sqrt(G * O(0).M * O(1).XP) / D
    omega = O(1).YV / O(1).XP
    Lagrange(GetPointNumber, O(2).XP, O(2).YP)
    ' set up the initial velocity of the satellite
    Select Case GetPointNumber()
      Case 6
        O(2).XV = 0 : O(2).YV = O(1).YV * NumericUpDown6.Value / 100
      Case 7
        O(2).XV = 0 : O(2).YV = Math.Sqrt(G * O(0).M / -O(2).XP) * NumericUpDown6.Value / 100
      Case Else
        O(2).XV = -O(2).YP * omega
        O(2).YV = O(2).XP * omega
    End Select
    'If GetPointNumber() = 6 Then O(2).YV = O(2).YV * NumericUpDown6.Value / 100
    ' set up the velocity of the star so that the momentum is zero
    O(0).XV = -(O(1).XV * O(1).M + O(2).XV * O(2).M) / O(0).M
    O(0).YV = -(O(1).YV * O(1).M + O(2).YV * O(2).M) / O(0).M
    ' set acceleration to zero so that first update does nothing
    SetAccel()
    angle = 0
    If Me.Visible Then ClearBitmap()
    Label4.Text = "Orbit No. 1"
    Label8.Text = ""
    PictureBox1.Invalidate()
  End Sub

  Private Sub Lagrange(ByVal n, ByRef x, ByRef y)
    Dim A As Double = D * O(1).M / (O(0).M + O(1).M)
    Dim B As Double = D * O(0).M / (O(0).M + O(1).M)
    Select Case n
      Case 1
        Dim F, dF As Double
        x = 10
        For i As Integer = 1 To 10
          F = G * O(1).M / (B - x) ^ 2 - G * O(0).M / (A + x) ^ 2 + x * omega ^ 2
          dF = 2 * G * O(1).M / (B - x) ^ 3 + 2 * G * O(0).M / (A + x) ^ 3 + omega ^ 2
          x = x - F / dF
        Next
        y = 0
      Case 2
        Dim F, dF As Double
        x = B + 50
        For i As Integer = 1 To 10
          F = -G * O(1).M / (x - B) ^ 2 - G * O(0).M / (A + x) ^ 2 + x * omega ^ 2
          dF = 2 * G * O(1).M / (x - B) ^ 3 + 2 * G * O(0).M / (A + x) ^ 3 + omega ^ 2
          x = x - F / dF
        Next
        y = 0
      Case 3
        Dim F, dF As Double
        x = A + 100
        For i As Integer = 1 To 10
          F = G * O(1).M / (B + x) ^ 2 + G * O(0).M / (x - A) ^ 2 - x * omega ^ 2
          dF = -2 * G * O(1).M / (B + x) ^ 3 - 2 * G * O(0).M / (x - A) ^ 3 - omega ^ 2
          x = x - F / dF
        Next
        x = -x
        y = 0
      Case 4, 5
        Dim FS, FE As Double
        Dim FX, dFX As Double
        Dim FY, dFY As Double
        Dim RE, RS As Double
        x = 100 : y = -173 ' rem y is negative
        For i As Integer = 1 To 100
          RS = Math.Sqrt((A + x) ^ 2 + y ^ 2)
          RE = Math.Sqrt((B - x) ^ 2 + y ^ 2)
          FS = G * O(0).M / RS ^ 2
          FE = G * O(1).M / RE ^ 2

          FX = -FS * (A + x) / RS
          FX += FE * (B - x) / RE
          FX += omega ^ 2 * x
          dFX = FE / RE * (3 * (B - x) ^ 2 / RE ^ 2 - 1)
          dFX += FS / RS * (3 * (A + x) ^ 2 / RS ^ 2 - 1)
          dFX += omega ^ 2
          x = x - FX / dFX

          FY = FS * y / RS
          FY += FE * y / RE
          FY += -omega ^ 2 * y
          dFY = FS / RS * (1 - 3 * y ^ 2 / RS ^ 2)
          dFY += FE / RE * (1 - 3 * y ^ 2 / RE ^ 2)
          dFY += -omega ^ 2
          y = y - FY / dFY

        Next
        If n = 5 Then y = -y
      Case 6 ' lunar
        x = B * NumericUpDown5.Value / 100 : y = 0
      Case 7 ' solar
        x = -B * NumericUpDown5.Value / 100 : y = 0
    End Select
  End Sub

  Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
    Reset()
  End Sub

  Private Sub NumericUpDown1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown1.ValueChanged
    O(0).M = NumericUpDown1.Value
    GetRadius()
    If Not Running Then Reset()
  End Sub
  Private Sub NumericUpDown2_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown2.ValueChanged
    O(1).M = NumericUpDown2.Value
    GetRadius()
    If Not Running Then Reset()
  End Sub
  Private Sub NumericUpDown3_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown3.ValueChanged
    O(2).M = NumericUpDown3.Value
    GetRadius()
    If Not Running Then Reset()
  End Sub
  Private Sub NumericUpDown56_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown5.ValueChanged, NumericUpDown6.ValueChanged
    If Not Running Then Reset()
  End Sub

  Private Function GetPointNumber()
    If RadioButton1.Checked Then Return 1
    If RadioButton2.Checked Then Return 2
    If RadioButton3.Checked Then Return 3
    If RadioButton4.Checked Then Return 4
    If RadioButton5.Checked Then Return 5
    If RadioButton6.Checked Then Return 6
    If RadioButton7.Checked Then Return 7
    Return 6
  End Function
  Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, RadioButton4.CheckedChanged, RadioButton5.CheckedChanged, RadioButton6.CheckedChanged, RadioButton7.CheckedChanged
    If sender.checked Then
      Dim f As Boolean = sender Is RadioButton6 Or sender Is RadioButton7
      NumericUpDown5.Enabled = f : Label5.Enabled = f
      NumericUpDown6.Enabled = f : Label6.Enabled = f
      Reset()
    End If
  End Sub
  Private Sub CheckBox2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox2.CheckedChanged
    ' rotating rerence frame
    angle = 0
    ClearBitmap()
    PictureBox1.Invalidate()
  End Sub

  Private Sub CheckBox3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox3.CheckedChanged
    ' grid
    ClearBitmap()
    PictureBox1.Invalidate()
  End Sub

  Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
    ' Clear trails
    ClearBitmap()
    PictureBox1.Invalidate()
  End Sub

  Private Sub ClearBitmap()
    BMg.ResetTransform()
    BMg.TranslateTransform(300, 300)
    BMg.Clear(Color.Black)
    If CheckBox3.Checked Then
      For x As Integer = -250 To 250 Step 50
        BMg.DrawLine(Pens.Gray, -300, x, 300, x)
        BMg.DrawLine(Pens.Gray, x, -300, x, 300)
      Next
      BMg.DrawLine(New Pen(Brushes.Gray, 3), -300, 0, 300, 0)
      BMg.DrawLine(New Pen(Brushes.Gray, 3), 0, -300, 0, 300)
    End If
    If CheckBox2.Checked Then BMg.RotateTransform(angle)
  End Sub

  Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
    Help.Show()
  End Sub

  Private Sub RadioButton8_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton8.CheckedChanged, RadioButton9.CheckedChanged
    If sender.checked Then
      If sender Is RadioButton8 Then
        Timer1.Interval = 10
      Else
        Timer1.Interval = 40
      End If
    End If
  End Sub

  Private Sub SaveImageButton_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
    SaveFileDialog1.FileName = "Image"
    If SaveFileDialog1.ShowDialog = DialogResult.OK Then
      SaveImage(SaveFileDialog1.FileName)
    End If
  End Sub

  Private Sub SaveImage(filename)
    If Not filename.EndsWith(".png") Then filename &= ".png"
    BM.Save(filename, ImageFormat.Png)
  End Sub
End Class
